#include <bits/stdc++.h>
using namespace std;
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

#define ll long long
#define ld long double
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define int long long
const int MOD = 1e9 + 7;
const int N = 1e5 + 100;
int h[N];
using namespace __gnu_pbds;
typedef tree<int, pair<int, int>, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_map;
vector<pair<int, pair<int,ll> > > sg[4 * N];

void build(int v, int tl, int tr) {
    for (int i = tl; i < tr; ++i) {
        if (sg[v].empty() || h[i] > sg[v].back().F) {
            sg[v].pb({h[i], {i, 0}});
        }
    }
    for (int i = (int) sg[v].size() - 2; i >= 0; i--) {
        sg[v][i].S.S = sg[v][i + 1].S.S + (ll) sg[v][i].F * (ll) (sg[v][i + 1].S.F - sg[v][i].S.F);
    }
    if (tr - tl == 1) {
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v, tl, tm);
    build(2 * v + 1, tm, tr);
}

vector<int> vec;

void get(int v, int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l) {
        return;
    }
    if (l <= tl && tr <= r) {
        vec.pb(v);
        return;
    }
    int tm = (tl + tr) / 2;
    get(2 * v, tl, tm, l, r);
    get(2 * v + 1, tm, tr, l, r);
}

vector<pair<int, pair<int,ll> > > sg2[4 * N];

void build2(int v, int tl, int tr) {
    for (int i = tr - 1; i >= tl; --i) {
        if (sg2[v].empty() || h[i] > sg2[v].back().F) {
            sg2[v].pb({h[i], {i, 0}});
        }
    }
    for (int i = (int) sg2[v].size() - 2; i >= 0; i--) {
        sg2[v][i].S.S = sg2[v][i + 1].S.S + (ll) sg2[v][i].F * (ll) (sg2[v][i + 1].S.F - sg2[v][i].S.F);
    }
    // for (int i = 1; i < (int) sg2[v].size(); i++) {
    //     sg[v][i].S.S = sg[v][i - 1].S.S + (ll) sg[v][i].F * (ll) (sg[v][i].S.F - sg[v][i - 1].S.F);
    // }
    if (tr - tl == 1) {
        return;
    }
    int tm = (tl + tr) / 2;
    build2(2 * v, tl, tm);
    build2(2 * v + 1, tm, tr);
}


void get2(int v, int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l) {
        return;
    }
    if (l <= tl && tr <= r) {
        vec.pb(v);
        return;
    }
    int tm = (tl + tr) / 2;
    get2(2 * v + 1, tm, tr, l, r);
    get2(2 * v, tl, tm, l, r);
}


ordered_map mp;
ll pref[N];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        mp[i] = {i, i};
        if (i != 0) {
            pref[i] = pref[i - 1];
        }
        pref[i] += h[i];
    }
    // for (auto it:mp) {
    //     cout << it.F << " " << it.S.F << "\n";
    // }
    build(1, 0, n);
    build2(1, 0, n);
    for (int i = 0; i < n - 1; ++i) {
        int k;
        cin >> k;
        --k;
        auto it = mp.find_by_order(k);
        int l = it->F;
        int r1 = it->S.F;
        int mx1 = it->S.S;
        ++it;
        int l2 = it->F;
        int r = it->S.F;
        int mx2 = it->S.S;
        mp.erase(it);
        int mx;
        if (h[mx1] > h[mx2]) {
            mx = mx1;
        } else {
            mx = mx2;
        }
        mp[l] = {r, mx};
        vec.clear();
        get(1, 0, n, l, mx);
        ll ans = 0;
        ll x = 0;
        ll idx = l;
        for (int v: vec) {
            pair<int, pair<int,ll> > a = {(int) x, {0, 0}};
            auto to = upper_bound(all(sg[v]), a);
            if (to!= sg[v].end()) {
                ans += x * (ll) (to->S.F - idx);
                ans += to->S.S;
                x = sg[v].back().F;
                idx = sg[v].back().S.F;
            }
        }
        ans += x * (mx - idx);
        vec.clear();
        get2(1, 0, n, mx + 1, r + 1);
        x = 0;
        idx = r;
        for (int v: vec) {
            pair<int, pair<int,ll> > a = {(int) x, {0, 0}};
            auto to = upper_bound(all(sg2[v]), a);
            if (to!=sg2[v].end()) {
                ans += x * (ll) (idx - to->S.F);
                ans += to->S.S;
                x = sg2[v].back().F;
                idx = sg2[v].back().S.F;
            }
        }
        ans += h[mx];
        ans += x * (idx - mx);
        ans -= pref[r];
        if (l > 0) {
            ans += pref[l - 1];
        }
        cout << ans << "\n";
    }
    return 0;
}
