#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define ld long double
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
// #define int long long
const int MOD = 1e9 + 7;

int add(int a, int b) {
    if (a + b < MOD) {
        return a + b;
    }
    return a + b - MOD;
}

int sub(int a, int b) {
    if (a - b < 0) {
        return a - b + MOD;
    }
    return a - b;
}

int mult(int a, int b) {
    return ((ll) a * (ll) b) % MOD;
}

int binpow(int a, int m) {
    if (m == 0) {
        return 1;
    }
    if (m % 2 == 1) {
        return mult(a, binpow(a, m - 1));
    }
    int x = binpow(a, m / 2);
    return mult(x, x);
}

const int N = 1e6 + 100;
int fact[N], fact1[N];

int c(int n, int k) {
    if (k == 0 || k == n) {
        return 1;
    }
    return mult(fact[n], mult(fact1[k], fact1[n - k]));
}

const int K = 2010;
int x[K], y[K];
vector<int> g[K], g2[K];
int col[K];
int d[K];

// void f(int k) {
//     d[k] = 1;
//     if (g2[k].size() <= 1) {
//         return;
//     }
//     int s = g2[k][0];
//     for (int i = 1; i < g2[k].size(); i++) {
//
//     }
// }

// void dfs(int v, int sum) {
//     for (int u: g[v]) {
//         if (col[u] == col[v]) {
//             cout << 0;
//             exit(0);
//         }
//         if (col[u] == 0) {
//             col[u] = sum - col[v];
//             g2[col[u]].pb(u);
//             dfs(u, sum);
//         }
//     }
// }

vector<pair<int, int> > v;
int dp[(1 << 17) + 10];
int n, m, k;
int dist[110][110];

int f(int s, int e) {
    if (dist[s][e] != -1) {
        return dist[s][e];
    }
    if (x[s] == x[e] && y[s] == y[e]) {
        return 1;
    }
    if (y[s] > y[e]) {
        return 0;
    }
    int ans = c(x[e] - x[s] + y[e] - y[s], x[e] - x[s]);
    for (int i = 1; i <= k; ++i) {
        if (i == s || i == e) {
            continue;
        }
        if (x[s] <= x[i] && x[i] <= x[e] && y[s] <= y[i] && y[i] <= y[e]) {
            ans = sub(ans, mult(f(s, i), c(x[e] - x[i] + y[e] - y[i], x[e] - x[i])));
        }
    }
    dist[s][e] = ans;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    fact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = mult(fact[i - 1], i);
    }
    fact1[N - 1] = binpow(fact[N - 1], MOD - 2);
    for (int i = N - 2; i >= 0; --i) {
        fact1[i] = mult(fact1[i + 1], i + 1);
    }

    cin >> n >> m >> k;
    for (int i = 1; i <= k; i++) {
        int _x, _y;
        cin >> _x >> _y;
        v.pb({_x, _y});
    }
    sort(all(v));
    x[0] = 1;
    y[0] = 1;
    for (int i = 0; i < k; ++i) {
        x[i + 1] = v[i].F;
        y[i + 1] = v[i].S;
    }
    x[k + 1] = n;
    y[k + 1] = m;
    for (int i = 1; i <= k; ++i) {
        int cnt0 = 0, cnt1 = 0;
        for (int j = 1; j <= k; ++j) {
            if (x[j] < x[i] && y[j] > y[i]) {
                cnt0++;
                g[i].pb(j);
            }
            if (x[j] > x[i] && y[j] < y[i]) {
                cnt1++;
                g[i].pb(j);
            }
        }
        if (cnt0 > 0 && cnt1 > 0) {
            cout << 0;
            return 0;
        }
    }
    if (k <= 16) {
        for (int i = 0; i < 20; ++i) {
            for (int j = 0; j < 20; ++j) {
                dist[i][j] = -1;
            }
        }
        dp[0] = 1;
        for (int mask = 1; mask < (1 << (k + 1)); ++mask) {
            int v = -1;
            int p = -1;
            int submask = mask;
            for (int j = k; j >= 0; --j) {
                if ((mask & (1 << j)) != 0) {
                    if (v == -1) {
                        submask -= (1 << j);
                        v = j + 1;
                    } else {
                        p = j + 1;
                        break;
                    }
                }
            }
            if (p == -1) {
                p = 0;
            }
            dp[mask] = mult(dp[submask], f(p, v));
        }
        int ans = 0;
        for (int mask = 0; mask < (1 << k); ++mask) {
            int mask1 = mask + (1 << (k));
            int mask2 = (1 << (k)) - 1 - mask;
            mask2 += (1 << (k));
            ans = add(ans, mult(dp[mask1], dp[mask2]));
            // cerr << mask1 << " " << mask2  << " " << mult(dp[mask1], dp[mask2]) << "\n";
        }
        ans = mult(ans, binpow(4, MOD - 2));
        cout << ans;
        return 0;
    }

    // int cnt = 1;
    // for (int i = 1; i <= k; ++i) {
    //     if (col[i] == 0) {
    //         col[i] = 2 * cnt - 1;
    //         g2[col[i]].pb(i);
    //         dfs(i, 4 * cnt - 1);
    //         cnt++;
    //         sort(all(g2[cnt]));
    //         sort(all(g2[cnt+1]));
    //     }
    // }
    // for (int mask = 0; mask < (1 << cnt); ++mask) {
    //
    // }
    return 0;
}
